// LARL  ()

#include<stdio.h>
#include<string.h>
#include<vector>
#include<algorithm>

// 
const char *GR[]={"S","(","S",")",0,"S","C","C",0,"C","c","C",0,"C","d",0,0};
//const char *GR[]={"S","L","=","R",0,"S","R",0,"L","*","R",0,"L","id",0,"R","L",0,0};
//const char *GR[]={"E","E","+","E",0,"E","E","*","E",0,"E","(","E",")",0,"E","id",0,0};
//const char *GR[]={"S","if","S","else","S",0,"if","S",0,"act",0,0};
//const char *GR[]={"E","E","+","T",0,"E","T",0,"T","T","*","F",0,"T","F",0,"F","(","E",")",0,"F","id",0,0};


struct goto_st;
struct gram_st;

// ===   ===

// 
struct symbol_st{
	static int last_id;
	int id;
	const char *name;	//  
	gram_st *grams;		//  ,     
	symbol_st *next;
}
	*symbol_list=0,		//   
	*symbol_slack=0;	//   

int symbol_st::last_id=0;

typedef std::vector<symbol_st*> symbol_line_st; //  


//   
symbol_st *SymbolID(const char *name)
{
	symbol_st *symbol=symbol_list;
	while(symbol) {
		if(!strcmp(symbol->name,name)) return symbol;
		symbol=symbol->next;
	}
	symbol=new symbol_st;
	symbol->id=symbol_st::last_id++;
	symbol->name=strdup(name);
	symbol->next=0;
	symbol->grams=0;
	if(symbol_list) symbol_slack->next=symbol,symbol_slack=symbol;
	else symbol_slack=symbol_list=symbol;
	return symbol;
}

// true   
bool isTerminal(symbol_st *sym)
{
	return !sym->grams;
}

// ===  ===

//  
struct gram_st{
	static int last_id;
	int id;
	symbol_line_st line;
	gram_st *next;
};

int gram_st::last_id=0;

//  	   
void GramAdd(gram_st *item)
{
	symbol_st *symbol=item->line[0];
	item->id=gram_st::last_id++;
	item->next=symbol->grams;
	symbol->grams=item;
}


// ===  ===

bool isIn(symbol_line_st &set,symbol_st *sym)
{
	for(int n=0; n<set.size(); n++) if(set[n]==sym) return true;
	return false;
}


//     
bool SetAdd(symbol_line_st &set,symbol_st *sym)
{
	for(int n=0; n<set.size(); n++) if(set[n]==sym) return false;
	set.push_back(sym);
	return true;
}

//   
bool SetAdd(symbol_line_st &set1,symbol_line_st &set2)
{
	bool res=false;
	for(int n=0; n<set2.size(); n++) res=SetAdd(set1,set2[n]) || res;
	return res;
}

//  first   
void GetFirstSet(symbol_line_st &set,symbol_st *sym) 
{
	symbol_line_st list; //    
	if(isTerminal(sym)) SetAdd(set,sym); else SetAdd(list,sym);
	for(int n=0; n<list.size(); n++) {
		gram_st *g=list[n]->grams;
		while(g) {
			if(g->line.size()>1) {
				sym=g->line[1];
				if(isTerminal(sym)) SetAdd(set,sym); else SetAdd(list,sym);
			}
			g=g->next;
		}
	}
}

// ===  ===

//  
struct state_item_st{ 
	int pos;				//  
	gram_st *gram;	//  
	bool final;				// true     
	symbol_line_st follow;	//  follow 
};


//  
struct state_st{
	static int last_id;
	int id;
	bool modify;					// true       (  )
	std::vector<state_item_st> list;// 
	goto_st *links;					//    
	state_st *next;
	state_st():links(0),next(0) {}
}*state_list=0;

int state_st::last_id=0;

//    
struct goto_st{
	symbol_st *symbol;	// 
	state_st *link;		//   
	goto_st *next;
};


//    
int StateItemCompare(state_item_st &obj1,state_item_st &obj2)
{
	if(obj1.gram->id<obj2.gram->id) return 1;
	if(obj1.gram->id>obj2.gram->id) return -1;
	return obj1.pos-obj2.pos;
}


//   
bool StateCompare(state_st *st1,state_st *st2)
{
	if(st1->list.size()!=st2->list.size()) return false;
	for(int n=0; n<st1->list.size(); n++) {
		if(StateItemCompare(st1->list[n],st2->list[n])) return false;
	}
	return true;
}

//    
void StateItemAdd(state_st *st,gram_st *item,int pos,symbol_line_st *set=0)
{
	for(int n=0; n<st->list.size(); n++) if(st->list[n].gram==item && st->list[n].pos==pos) {
		if(set) SetAdd(st->list[n].follow,*set);
		return;
	}
	state_item_st i;
	i.gram=item;
	i.pos=pos;
	i.final=(pos==item->line.size()-1);
	if(set) i.follow=*set;
	st->list.push_back(i);
}


//   
void StateSort(state_st *st)
{
//	std::sort(st->list.begin(),st->list.end()-1,StateItemCompare);
	bool loop;
	do {
		loop=false;
		for(int n=1; n<st->list.size(); n++) {
			if(StateItemCompare(st->list[n-1],st->list[n])>=0) continue;
			loop=true;
			std::swap(st->list[n-1],st->list[n]);
		}
	}while(loop);
}


//  (  )
void StateExtent(state_st *state)
{
	for(int n=0; n<state->list.size(); n++) {
		symbol_line_st set;
		gram_st *gr=state->list[n].gram;
		int     pos=state->list[n].pos+1;
		if(pos>=gr->line.size()) continue;
		symbol_st *sym=gr->line[pos];
		gram_st *list=sym->grams;
		if(pos+1==gr->line.size()) set=state->list[n].follow; else 	GetFirstSet(set,gr->line[pos+1]);
		while(list) {
			StateItemAdd(state,list,0,&set);
			list=list->next;
		}
	}
}

//     
goto_st *StateShift(state_st *state)
{
	state->modify=false;
	goto_st *it,*list=0;
	for(int n=0; n<state->list.size(); n++) {
		state_item_st *item=&state->list[n];
		if(item->final) continue;
		int pos=item->pos+1;
		symbol_st *sym=item->gram->line[pos];
		it=list;
		while(it) {
			if(it->symbol==sym) break;
			it=it->next;
		}
		if(!it) {
			it=new goto_st;
			it->symbol=sym;
			it->link=new state_st;
			it->next=list;
			list=it;
		}
		StateItemAdd(it->link,item->gram,pos,&item->follow);
	}
	return list;
}

//    ( )
void StateMerge(state_st *st1,state_st *st2)
{
	for(int n=0; n<st1->list.size(); n++) 
		if(SetAdd(st1->list[n].follow,st2->list[n].follow)) st1->modify=true;
}

//    
// state -  
// from  -      
// sym   -     
void StateAdd(state_st *state,state_st *from,symbol_st *sym)
{
	StateExtent(state);
	StateSort(state);

	goto_st *link;
	state_st **it=&state_list;
	while(*it) {
		if(StateCompare(*it,state)) { 
			StateMerge(*it,state); //  
			for(link=from->links; link; link=link->next) if(link->symbol==sym) return;
			break;
		}
		it=&(*it)->next;
	}
	if(!*it) {
		*it=new state_st(*state);
		(*it)->modify=true;
		(*it)->id=state_st::last_id++;
	}
	if(from && sym) {
		link=new goto_st;
		link->symbol=sym;
		link->link=*it;
		link->next=from->links;
		from->links=link;
	}
}


// ===  ===

void DumpState(state_st *state);

void Init()
{
	int n;
//  
	symbol_line_st list;
	for(n=0;; n++) {
		if(GR[n]) list.push_back(SymbolID(GR[n]));
		else {
			gram_st *i=new gram_st;
			i->line=list;
			GramAdd(i);
			if(!GR[n+1]) break;
			list.clear();
		}
	}
//   
	//   
	state_st state0; 
	symbol_line_st end_set; end_set.push_back(SymbolID("$end"));
	for(gram_st *g=symbol_list->grams;g;g=g->next) StateItemAdd(&state0,g,0,&end_set);
	StateAdd(&state0,0,0);
	//  ,  
	bool loop;
	do{
		loop=false;
		state_st *it=state_list;
		while(it) {
			if(it->modify) {
				loop=true;
				goto_st *l=StateShift(it);
				while(l) {
					goto_st *next=l->next;
					StateAdd(l->link,it,l->symbol);
					delete l->link;
					delete l; l=next;
				}
			}
			it=it->next;
		}
	}while(loop);
}


// === dump ===

//  
void DumpSet(symbol_line_st &set,FILE *file=stdout)
{
	if(set.empty()) return;
	fputc('[',file);
	for(int n=0; n<set.size(); n++) {
		if(n) fputc(' ',file);
		fprintf(file,"%s",set[n]->name);
	}
	fputc(']',file);
}

//  
void DumpGram(FILE *file=stdout)
{
	int n;
	symbol_st *sym=symbol_list;
	while(sym) {
		gram_st *list=sym->grams;
		while(list) {
			fprintf(file,"%02d:",list->id);
			for(n=0; n<list->line.size(); n++) {
				fprintf(file," %s",list->line[n]->name);
				if(!n) fprintf(file," ->");
			}
			fputc('\n',file);
			list=list->next;
		}
		sym=sym->next;
	}
}

//  
void DumpState(state_st *state,FILE *file=stdout)
{
	int n,m;
	fprintf(file,"\n[state:%d]\n",state->id);
	for(n=0; n<state->list.size(); n++) {
		gram_st *gr=state->list[n].gram;
		int     pos=state->list[n].pos;
		for(m=0; m<gr->line.size(); m++) {
			if(m) fputc(' ',file);
			fprintf(file,"%s",gr->line[m]->name);
			if(m==pos) fputc('.',file);
		}
		fputc('\t',file);
		DumpSet(state->list[n].follow,file);
		fputc('\n',file);
	}
	fprintf(file,"::");
	goto_st *link=state->links;
	while(link) fprintf(file," %d[%s]",link->link->id,link->symbol->name),link=link->next;
	fputc('\n',file);
}

//   
void DumpStates(FILE *file=stdout)
{
	state_st *list=state_list;
	while(list) {
		DumpState(list,file);
		list=list->next;
	}
}

//    dot
void DumpGraph()
{
	FILE *file=fopen("1.dot","wt");
	int n,m;
	fprintf(file,"digraph G{\nnode [shape=box]\n");
	state_st *state=state_list;
	while(state) {
		fprintf(file,"%d [label=\"[state:%d]\\n",state->id,state->id);
		for(n=0; n<state->list.size(); n++) {
			gram_st *gr=state->list[n].gram;
			int     pos=state->list[n].pos;
			for(m=0; m<gr->line.size(); m++) {
				if(m) fputc(' ',file);
				fprintf(file,"%s",gr->line[m]->name);
				if(m==pos) fputc('.',file);
				if(!m) fprintf(file," &rarr;");
			}
			fprintf(file,"  ");
			DumpSet(state->list[n].follow,file);
			fprintf(file,"\\n");
		}
		fprintf(file,"\"]\n");
		goto_st *g=state->links;
		while(g) {
			fprintf(file,"%d -> %d [label=\"%s\"]\n",state->id,g->link->id,g->symbol->name);
			g=g->next;
		}
		state=state->next;
	}
	fprintf(file,"}\n");
	fclose(file);
}

//     html 
void DumpHtmlTable()
{
	FILE *file=fopen("1.html","wt");
	symbol_st *sym; state_st *list; goto_st *l;
	fprintf(file,"<pre>");
	DumpGram(file);
	fprintf(file,"</pre>");
	fprintf(file,"<table border=1 cellpadding=4 cellspacing=0><tr><td>.");
	for(sym=symbol_list;sym;sym=sym->next) if( isTerminal(sym)) fprintf(file,"<td style='background-color:Azure'>%s",sym->name);
	for(sym=symbol_list;sym;sym=sym->next) if(!isTerminal(sym)) fprintf(file,"<td>%s",sym->name);
	list=state_list;
	while(list) {
		fprintf(file,"\n<tr><td>%d",list->id);
		for(sym=symbol_list;sym;sym=sym->next) {
			if(!isTerminal(sym)) continue;
			bool empty=true;
			fprintf(file,"<td style='background-color:Azure'>");
			l=list->links;
			while(l) {
				if(l->symbol==sym) {fprintf(file,"s%d",l->link->id);empty=false;break;}
				l=l->next;
			}
			for(int n=0; n<list->list.size(); n++) {
				if(list->list[n].final && isIn(list->list[n].follow,sym)) 
					fprintf(file,"r%d",list->list[n].gram->id),empty=false;
			}
			if(empty) fputc('.',file);
		}
		for(sym=symbol_list;sym;sym=sym->next) {
			if(isTerminal(sym)) continue;
			fprintf(file,"<td>");
			l=list->links;
			while(l) {
				if(l->symbol==sym) {fprintf(file,"%d",l->link->id);break;}
				l=l->next;
			}
			if(!l) fputc('.',file);
		}
		list=list->next;
	}
	fprintf(file,"\n</table>");
	fclose(file);
}

//    
void DumpSource()
{
	FILE *file=fopen("1.h","wt");
// 
	symbol_st *sym; int n;
	fprintf(file,"const char *symbols[]={\n");
	for(sym=symbol_list; sym; sym=sym->next) fprintf(file,"\t\"%s\",\t//%d\n",sym->name,sym->id);
	fprintf(file,"\t0\n};\n");
// 
	//  
	for(sym=symbol_list; sym; sym=sym->next) {
		for(gram_st *g=sym->grams;g;g=g->next) {
			fprintf(file,"const int g%d[]={",g->id);
			for(n=0; n<g->line.size(); n++) fprintf(file,"%d,",g->line[n]->id);
			fprintf(file,"-1};\n");
		}
	}
	//  
	fprintf(file,"const int *gram[]={");
	for(n=0; n<gram_st::last_id; n++) {
		if(n) fputc(',',file);
		fprintf(file,"g%d",n);
	}
	fprintf(file,"};\n");
// 
	fprintf(file,"const state_st table[]={\n");
	for(state_st *list=state_list; list; list=list->next) {
		goto_st *l=list->links;
		while(l) {
			sym=l->symbol;
			fprintf(file,"\t{%d,%d /* %s */,%d,state_st::shift},\n",list->id,sym->id,sym->name,l->link->id);
			l=l->next;
		}
		for(n=0; n<list->list.size(); n++) {
			if(list->list[n].final) {
				state_item_st &item=list->list[n];
				symbol_line_st &set=item.follow;
				for(int m=0; m<set.size(); m++) 
					fprintf(file,"\t{%d,%d /* %s */,%d,state_st::reduce},\n",list->id,set[m]->id,set[m]->name,item.gram->id);
			}
		}
	}
	fprintf(file,"\t{0,0,0,state_st::end}\n");
	fprintf(file,"};\n");
	fclose(file);
}


int main()
{
	Init();
	DumpGram();
	DumpStates();
	DumpGraph();
	DumpHtmlTable();
	DumpSource();
	//getchar();
	return 0;
}

